
% --- (C) Josefin Ahlkrona & Victor Shcherbakov 2016 ---

function Tri = findTriangulation(x,y,boundaryindeces)
 
Points=[x,y];

 
% C contains all the edges that makes up the boundary. So lets say
% that point 7 9 2  and 1 are on the boundary connected to eachother
% making a loop then C would be [7 9; 9 2; 2 1; 1 7]
C=[];
for i=1:length(boundaryindeces)-1
    j=boundaryindeces(i);
    jnext=boundaryindeces(i+1);
    C=[C; j jnext];
end
C=[C; boundaryindeces(end) boundaryindeces(1)];

% Now I make a triangulation of the points, giving matlab info of 
% how the boundary C looks
DT=delaunayTriangulation(Points,C);

% This finds all the elements that are inside the polygon
IO=isInterior(DT);

% Tri contains info on which points are in each triangle
Tri=DT.ConnectivityList(IO,:);



% plot triangulation
% figure;
% triplot(DT(IO, :),DT.Points(:,1), DT.Points(:,2),'LineWidth', 2)

 end